using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PhoenixUserManager.Class;
using MySql.Data.MySqlClient;

namespace PhoenixUserManager.GUI
{
    public partial class fr_Inscription : Form
    {
        #region Variables
        /// <summary>
        /// Information about the new user
        /// </summary>
        private UserManager vUserManager =
            new UserManager("PhoenixUserManag", "", "jibedoubleve.mine.nu", "Phoenix", "Phoenix");
        /// <summary>
        /// Indicates whether the Inscription was cancelled
        /// </summary>
        private bool vInscriptionCancelled = false;
        #endregion

        #region Constructor
        /// <summary>
        /// Constructor
        /// </summary>
        public fr_Inscription() { InitializeComponent(); }
        #endregion

        #region Events
        /// <summary>
        /// Frame load
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Event_FrameLoad(object sender, EventArgs e)
        {
            UserManager um = new UserManager("PhoenixUserManag", "", "jibedoubleve.mine.nu", "Phoenix", "Phoenix");
            try
            {
                um.GetIDInRegistry();
                this.Close();

            }
            catch (NullReferenceException)
            {
                DialogResult dr = MessageBox.Show("Phoenix Suite n'a pas trouv votre inscription. Etes-vous inscrit?"
                    + "\r\n[OUI    ] Va vous donner une boite de recherche pour retrouver votre inscription."
                    + "\r\n[NON    ] Va ouvrir la boite d'inscription."
                    + "\r\n[ANNULER] Va annuler l'inscription ce qui dsactivera le menu de rapport pour cette fois",
                    "Question", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question);

                if (dr == DialogResult.No) //Inscription
                    pg_User.SelectedObject = this.vUserManager;
                else if (dr == DialogResult.Yes) //Seek inscription
                {
                    fr_SearchUser fr = new fr_SearchUser();
                    fr.Software = this.vUserManager.Software;
                    fr.ShowDialog();
                    this.Close();
                }
                else //if(dr == DialogResult.Cancel) //CANCEL Report menu
                {
                    vInscriptionCancelled = true;
                    this.Close();
                }
            }
        }
        /// <summary>
        /// Click on cancel
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void MenuClick_Cancel(object sender, EventArgs e)
        {
            base.DialogResult = DialogResult.Cancel;
            this.Close();
        }
        /// <summary>
        /// Click on OK
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void MenuClick_OK(object sender, EventArgs e)
        {
            try
            {                
                vUserManager.Fill((int)vUserManager.Add());
                #region Set in Registry
                int _Value = vUserManager.UserID;
                UserManager.SetInRegistry(_Value, vUserManager.Software);
                #endregion

                base.DialogResult = DialogResult.OK;
                this.Close();
            }
            catch (MySqlException ex)
            {
                MessageBox.Show("Une erreur est survenue au niveau de la base de donnes"
                + ", l'inscription est impossible! (" + ex.Message + ")",
                "Attention", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                base.DialogResult = DialogResult.Cancel;
                this.Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show("Une erreur est survenue, l'inscription est impossible! (" + ex.Message + ")",
                    "Attention", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                base.DialogResult = DialogResult.Cancel;
                this.Close();
            }
        }
        #endregion

        #region Properties
        /// <summary>
        /// Indicates whether the inscription was cancelled or not
        /// </summary>
        public bool InscriptionCancelled { get { return vInscriptionCancelled; } }
        #endregion
    }
}